// TestPipesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestPipes.h"
#include "TestPipesDlg.h"
#include ".\testpipesdlg.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTestPipesDlg dialog
HANDLE hReadPipe;
HANDLE hWritePipe;


CTestPipesDlg::CTestPipesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestPipesDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestPipesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT1, mShell);
	DDX_Control(pDX, IDC_EDIT2, mSendText);
	DDX_Control(pDX, IDC_EDIT3, mExecutable);
}

BEGIN_MESSAGE_MAP(CTestPipesDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
END_MESSAGE_MAP()


// CTestPipesDlg message handlers

BOOL CTestPipesDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	mExecutable.SetWindowText("cmd.exe");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestPipesDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestPipesDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

static VOID GatherThread(LPVOID pVoid)
{	char Buffer[1024];
	DWORD dwRead;
	CTestPipesDlg * pDlg = (CTestPipesDlg * )pVoid;
	CString text;

	while (ReadFile(hReadPipe, Buffer, 1024, &dwRead, NULL))
	{
		pDlg->mShell.GetWindowText(text);
		text += CString(Buffer,dwRead);
		pDlg->mShell.SetWindowText(text);
		pDlg->mShell.LineScroll(10000, 0);
	}
}

void CTestPipesDlg::OnBnClickedButton1()
{
	HANDLE hTargetStdout = NULL;
	HANDLE hTargetStdin= NULL;
	HANDLE hTargetStderr= NULL;
	SECURITY_ATTRIBUTES tSA;
	char Cmd[1024];
	
	// Get executable
	ZeroMemory( Cmd, 1024);
	mExecutable.GetWindowText(Cmd, 1024);

	// Initialize handles
	hReadPipe= NULL;
	hWritePipe= NULL;

	// Initialize SA
	tSA.nLength = sizeof(tSA);
    tSA.lpSecurityDescriptor = NULL; // Use default ACL
    tSA.bInheritHandle = TRUE; // Shell will inherit handles

	// Create pipes
	// Stdout
	if (0 == CreatePipe(&hReadPipe, &hTargetStdout, &tSA, 0))
	{
        mShell.SetWindowText(_T("Cannot create stdout pipe\r\n"));
		return;
	}
	// Stdin
	if (0 == CreatePipe(&hTargetStdin, &hWritePipe,
                          &tSA, 0))
	{
        mShell.SetWindowText(_T("Cannot create stdout pipe\r\n"));
		return;
	}
	// Stderr (duplicate stdout)
	DuplicateHandle(GetCurrentProcess(), hTargetStdout,
		GetCurrentProcess(), &hTargetStderr,
			DUPLICATE_SAME_ACCESS , TRUE, 0);

	// Create the process
	PROCESS_INFORMATION tPI;
    STARTUPINFO tSI;
    HANDLE hProcess = NULL;

	// Prepare Startup Info
	ZeroMemory(&tSI, sizeof(tSI));
	tSI.cb = sizeof(tSI);
	tSI.hStdError = hTargetStderr;
	tSI.hStdOutput = hTargetStdout;
	tSI.hStdInput = hTargetStdin;
	tSI.wShowWindow = SW_HIDE;
	tSI.dwFlags = 
		STARTF_FORCEOFFFEEDBACK	|	// Dont get the clock cursor
		STARTF_USESHOWWINDOW		|	// Read what we selected for window
		STARTF_USESTDHANDLES;			// Use our handles

	
	//	tSI.cb = sizeof(tSI);
	// Prepare process info
	
	if (!CreateProcess(
		NULL,			// Application Name
		Cmd,				// Command line
		NULL,				// Process Security AT
		NULL,				// Thread Security AT
		TRUE,				// Inherit Handles
		0,					// Creating flags
		NULL,				// Enviroment
		NULL,				// CurrentDirectory
		&tSI,				// Startup info
		&tPI				// Process Information
		)
	)
	{
        mShell.SetWindowText(_T("Cannot start process\r\n"));
		int i = GetLastError();
		return;
	}

	DWORD dwExitCode;

	// Get exit code
	//WaitForSingleObject(tPI.hProcess, 3000);
	//GetExitCodeProcess(tPI.hProcess, &dwExitCode);

	int i = GetLastError();

	// Start collecting thread
	HANDLE hThread;
	SECURITY_ATTRIBUTES threadSA;	// Sa for thread
	threadSA.bInheritHandle = TRUE;
	threadSA.nLength = sizeof(threadSA);
	threadSA.lpSecurityDescriptor = NULL;
	DWORD dwThreadID;
	if ((hThread = CreateThread(&threadSA,
		1024,
		(LPTHREAD_START_ROUTINE)GatherThread,
		this,
		0,
		&dwThreadID
		)) == INVALID_HANDLE_VALUE)
	{
		    mShell.SetWindowText(_T("Cannot start thread\r\n"));
			return;
	}
}

void CTestPipesDlg::OnBnClickedButton2()
{
	CString inputText;
	char Buffer[1024];
	DWORD bytesInBuf, wroteBytes;

	mSendText.GetWindowText(inputText);
	inputText += CString("\r\n");
	bytesInBuf = inputText.GetLength();
	ZeroMemory(Buffer, 1024);
	strncpy(Buffer, inputText.GetBuffer(), bytesInBuf);
	WriteFile(hWritePipe, Buffer, bytesInBuf, &wroteBytes, NULL);
	mSendText.SetWindowText("");
}
